"""
/***************************************************************************
 LumigisConfig
                                 A QGIS plugin
 Configuration gestion du patrimoine éclairage public
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2023-07-12
        git sha              : $Format:%H$
        copyright            : (C) 2023 by Jean-Marie Arsac
        email                : jmarsac@azimut.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import yaml
from yaml.loader import SafeLoader


class LumigisConfig:
    """QGIS Plugin Implementation."""

    CONFIG_DICT = {}
    GIS_CONFIG = {}
    APS_CONFIG = {}
    UNKNOWN_USAGE = "?????"

    def __init__(self):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        print("__init__")

    @classmethod
    def unknown(cls):
        return cls.UNKNOWN_USAGE

    @classmethod
    def config_dict(cls):
        return cls.CONFIG_DICT

    @classmethod
    def set_gis_config(cls, usage):
        try:
            cls.GIS_CONFIG = cls.CONFIG_DICT["gis"][usage]
        except Exception as e:
            print(str(e))

    @classmethod
    def set_aps_config(cls, usage):
        try:
            cls.APS_CONFIG = cls.CONFIG_DICT["aps"][usage]
        except Exception as e:
            print(str(e))

    @classmethod
    def gis_config(cls):
        return cls.GIS_CONFIG

    @classmethod
    def aps_config(cls):
        return cls.APS_CONFIG

    @classmethod
    def load_config(cls, config_path):
        try:
            print(config_path)
            with open(config_path) as f:
                cls.CONFIG_DICT = yaml.load(f, Loader=SafeLoader)[0]["lumigis"]
                print("ok")
        except Exception as e:
            print(str(e))

    @classmethod
    def layer_shortname(cls, layer_name):
        for lay in LumigisConfig.gis_config()["lux_layers"]:
            if LumigisConfig.gis_config()["lux_layers"][lay]["name"] == layer_name:
                return LumigisConfig.gis_config()["lux_layers"][lay]["short_name"]
        for lay in LumigisConfig.gis_config()["fdp_layers"]:
            if LumigisConfig.gis_config()["fdp_layers"][lay]["name"] == layer_name:
                return LumigisConfig.gis_config()["fdp_layers"][lay]["short_name"]


if __name__ == "__main__":
    c = LumigisConfig()
    c.load_config(
        "c:/src/azimut/qgis/plugins/lumigis/lumigis/resources/settings/lumigis.yml"
    )
    d = c.config_dict()
    print(d)
    c.set_gis_config("sde22")
    d = c.gis_config()
    print(d)
    sn = c.layer_shortname("Foyers")
    print(sn)
